-module(active_emakefile).
-behaviour(gen_server).

-export([start_link/0, init/1, handle_call/3, handle_cast/2, handle_info/2, terminate/2, code_change/3]).

% read and save Emakefile data


start_link() -> gen_server:start_link({local, ?MODULE}, ?MODULE, [], []).


init([]) ->
  erlang:self() ! init,
  State = [],
  {ok, State}.


%handle_call(_Request, _From, State) -> {reply, ok, State}.
handle_call({get_data, App_Name}, _From, State) ->
  App_Data = get_app_data(State, App_Name),
  {reply, App_Data, State}.

handle_cast(_Request, State) -> {reply, ok, State}.

handle_info(init, _State0) ->
  State = emakefile_to_data(),
  {noreply, State};
handle_info(_Request, State) -> {noreply, State}.

terminate(_Reason, _State) -> ok.

code_change(_OldVsn, State, _Extra) -> {ok, State}.



emakefile_to_data() ->
  Emakefile = filename:absname("") ++ "/Emakefile",
  {ok, Data} = file:consult(Emakefile),
  % add app name to Data structure, wrap to list if path is string --
  %            [{"deps/ranch/src/*", [{outdir,"deps/ebin"}]}, ..] ->
  % [{"ranch", ["deps/ranch/src/*"], [{outdir,"deps/ebin"}]}, ..]
  add_app_names(Data, []).

add_app_names([], Acc) -> lists:reverse(Acc);
add_app_names([{H, S}|T], Acc) ->
  %Is_String = erlang:is_list(H) andalso H /= [] andalso erlang:is_integer(erlang:hd(H)),
  Is_String = erlang:is_integer(erlang:hd(H)),
  case Is_String of
    true ->
      App_Name = lists:nth(2, string:split(H, "/", all)),
      H2 = [H];
    _ ->
      App_Name = lists:nth(2, string:split(erlang:hd(H), "/", all)),
      H2 = H
  end,
  add_app_names(T, [{App_Name, H2, S}|Acc]).


get_app_data([], _) -> undefined; % not found
%get_app_data(State, App_Name) ->
get_app_data([{App, H, S}|T], App_Name) ->
  case App =:= App_Name of
    true ->
      {H, S};
    _ ->
      get_app_data(T, App_Name)
  end.

